var app = angular.module('appTreats', ['ngRoute']);

app.directive('myDirective', function() {
  return {
    require: 'ngModel',
    link: function(scope, element, attr, mCtrl) {
      function validHhNumber(value) {
        console.log("Communinty code is: " + scope.PIN_Community_code_YES);
        var db = openDatabase('treats', '1.0', 'TREATS DB', 5 * 1024 * 1024);

        db.transaction(function(transaction) {
          transaction.executeSql('SELECT * FROM household_tbl where PIN_Community_code_YES = ? AND PIN_Household_number = ?', [scope.PIN_Community_code_YES, value], function (tx, results) {
            if (results.rows.length != 0) {
              mCtrl.$setValidity('unused', false);
            } else {
              mCtrl.$setValidity('unused', true);
            }

            scope.$apply();
            return value;
          }, function(tx, error) {
            alert('Error: ' + error.message);
          });
        });

        return value;
      }
      mCtrl.$parsers.push(validHhNumber);
    }
  };
});

app.directive('validateMinMaxUnknown', function (){
  return {
     require: 'ngModel',
     link: function(scope, elem, attr, ngModel) {
         //For DOM -> model validation
         ngModel.$parsers.unshift(function(value) {
             var min = parseInt(attr.min), max = parseInt(attr.max), unknown = parseInt(attr.unknown);
             console.log("Min: " + min);
             console.log("Max: " + max);
             console.log("Unknown: " + unknown);

             if (max > 10) {
               max = 10;
             }

            var valid = (value >= min && value <= max) || (value == unknown);
            ngModel.$setValidity('valid_value', valid);
            return valid ? value : undefined;
         });

         //For model -> DOM validation
         ngModel.$formatters.unshift(function(value) {
             var min = parseInt(attr.min), max = parseInt(attr.max), unknown = parseInt(attr.unknown);
             console.log("Min: " + min);
             console.log("Max: " + max);
             console.log("Unknown: " + unknown);

             if (max > 10) {
               max = 10;
             }
            var valid = (value >= min && value <= max) || (value == unknown);
            ngModel.$setValidity('valid_value', valid);
            return value;
         });
     }
  };
});

function getPin(com_code, hh, ppin) {
  comcode = com_code.toString().padStart(2, '0'),
  hh = hh.toString().padStart(4, '0'),
  pin = ppin.toString().padStart(2, '0');
  return comcode.concat(hh, pin);
}


app.config(function($routeProvider) {
  $routeProvider

  .when('/', {
    templateUrl : 'pages/home.html',
    controller  : 'HomeController'
  })

  .when('/enumerate', {
    templateUrl : 'pages/enumerate.html',
    controller  : 'EnumerateController'
  })

  .when('/list', {
    templateUrl : 'pages/list.html',
    controller  : 'ListController'
  })

  .when('/export', {
    templateUrl : 'pages/export.html',
    controller  : 'ExportController'
  })

  .otherwise({redirectTo: '/'});
});

app.controller('HomeController', function($scope) {
  $scope.message = 'Hello from HomeController';

  $scope.printSomething = function() {

  }
});

app.controller('EnumerateController', function($scope) {
  $scope.message = 'Hello from EnumerateController';

  $scope.formData = {};
  $scope.formData.members = [];
  $scope.member = {}
  $scope.HhEnumerated = false;

  $scope.templates = [{
    name: 'member_list.html',
    url: 'member_list.html'
  }, {
    name: 'member_add.html',
    url: 'member_add.html'
  }];

  $scope.template = $scope.templates[0];



  $scope.newMemberInitiate = function() {
    $scope.template = $scope.templates[1];
    $scope.member = {};
    $scope.member.PIN_Participant_number = $scope.formData.members.length + 1;

    var comcode = String($scope.PIN_Community_code_YES),
        hh = String($scope.PIN_Household_number),
        p = String($scope.member.PIN_Participant_number);

    while (comcode.length != 2) { comcode = "0" + comcode; }
    while (hh.length != 4) { hh = "0" + hh; }
    while (p.length != 2) { p = "0" + p; }

    var pin = String(comcode) + String(hh) + String(p);
    $scope.member.PIN = pin;

  }

  $scope.generatePin = function() {
      var comcode = String($scope.PIN_Community_code_YES).padStart(2, '0'),
      hh = String($scope.PIN_Household_number).padStart(4, '0'),
      pin = String($scope.member.PIN_Participant_number).padStart(2, '0');
      $scope.member.PIN = comcode.concat(hh, pin).toString();
      alert("Something!");
  }

  $scope.printPin = function() {
    sendToPrinter($scope.member.PIN);
    // //open printing app
    // startApp.set({ /* params */
    //   "intent": "com.epson.lwprint.sdk.simpledemo.PRINT"
    // }).start(function() { /* success */
    //   alert.log("OK");
    // }, function(error) { /* fail */
    //   alert(error);
    // }, function() { // optional broadcast and forResult callback
    //   alert(arguments);
    // });
  }

  $scope.submitForm = function(isValid) {
    $scope.formData.members.push($scope.member);

    if ($scope.member.Census_HH == '1') {
      $scope.HhEnumerated = true;
    }

    $scope.member = {}

    $scope.template = $scope.templates[0];

    // if (isValid) {
    //     // $scope.memberForm.$setPristine();
    //     // $scope.apply();
    //     console.log($scope.formData.members);
    // }
  }

  $scope.enumerateSubmit = function() {
    $('#submit-form').attr('disabled', true);

    var hhmembers = $scope.formData.members;
    var len = parseInt(hhmembers.length), i;

    var executeQuery = "INSERT INTO household_tbl (" +
                        "Census_permissionHHinterview,";

    var values = [
      $scope.Census_permissionHHinterview
    ];

    if ($scope.Census_permissionHHinterview == '1') {
      executeQuery += "Census_date," +
      "PIN_Community_code_YES," +
      "Census_zone_number_YES," +
      "Census_block_number_YES," +
      "Census_plot_house_number_YES," +
      "PIN_Household_number," +
      "Census_GPS_Waypoint," +
      "Census_interviewer_name," +
      "Census_interviewer_code," +
      "Census_HHresults," +
      "Census_HH_results_Other, " +
      "SES_ECBUILD," +
      "SES_ECBUILD_Other," +
      "SES_ECFLOOR," +
      "SES_ECFLOOR_Other," +
      "SES_ECROOM," +
      "SES_ECROOMSLEEP," +
      "SES_ECWATER," +
      "SES_ECWATER_Other," +
      "SES_ECENERGY," +
      "SES_ECENERGY_Other," +
      "SES_ECTOILET," +
      "SES_ECTOILET_Other," +
      "SES_ECITEM1," +
      "SES_ECITEM2," +
      "SES_ECITEM3," +
      "SES_ECITEM4," +
      "SES_ECITEM5," +
      "SES_ECITEM6," +
      "SES_ECITEM7," +
      "SES_ECITEM8," +
      "SES_ECITEM9," +
      "SES_ECITEM10," +
      "SES_ECITEM11," +
      "SES_ECITEM12," +
      "SES_ECITEMNR," +
      "SES_ECITEM0," +
      "SES_ECINCOME," +
      "SES_ECINCOME_Other," +
      "SES_ECGRANT," +
      "SES_ECCHILDNUM_SA," +
      "SES_ECPENSNUM_SA," +
      "SES_ECFOSTNUM_SA," +
      "SES_ECDISNUM_SA," +
      "SES_ECOTHNUM_SA," +
      "SES_ECOTHNUM_SA_Other," +
      "SES_ECCTFSWGNU_Z," +
      "SES_ECOTHNUM_Z," +
      "SES_ECOTHNUM_OTHER_Z," +
      "SES_ECFSMON," +
      "SES_ECRELIEF," +
      "SES_ECMEALS," +
      "SES_ECSHORT," +
      "SES_ECHHITEM," +
      "SES_ECBOR," +
      "SES_ECBELONG," +
      "SES_ECAWAY) VALUES (?,?,?,?,?,?,?,?,?,?,?,?";
      executeQuery += ", ?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?," +
            "?);";

      values = values.concat([
        $scope.Census_date,
        $scope.PIN_Community_code_YES,
        $scope.Census_zone_number_YES,
        $scope.Census_block_number_YES,
        $scope.Census_plot_house_number_YES,
        $scope.PIN_Household_number,
        $scope.Census_GPS_Waypoint,
        $scope.Census_interviewer_name,
        $scope.Census_interviewer_code,
        $scope.Census_HHresults,
        ($scope.Census_HHresults == '8' ? $scope.Census_HH_results_Other : "null"),
        $scope.SES_ECBUILD,
        $scope.SES_ECBUILD_Other,
        $scope.SES_ECFLOOR,
        $scope.SES_ECFLOOR_Other,
        $scope.SES_ECROOM,
        $scope.SES_ECROOMSLEEP,
        $scope.SES_ECWATER,
        $scope.SES_ECWATER_Other,
        $scope.SES_ECENERGY,
        $scope.SES_ECENERGY_Other,
        $scope.SES_ECTOILET,
        $scope.SES_ECTOILET_Other,
        $scope.SES_ECITEM1,
        $scope.SES_ECITEM2,
        $scope.SES_ECITEM3,
        $scope.SES_ECITEM4,
        $scope.SES_ECITEM5,
        $scope.SES_ECITEM6,
        $scope.SES_ECITEM7,
        $scope.SES_ECITEM8,
        $scope.SES_ECITEM9,
        $scope.SES_ECITEM10,
        $scope.SES_ECITEM11,
        $scope.SES_ECITEM12,
        $scope.SES_ECITEMNR,
        $scope.SES_ECITEM0,
        $scope.SES_ECINCOME,
        $scope.SES_ECINCOME_Other,
        $scope.SES_ECGRANT,
        $scope.SES_ECCHILDNUM_SA,
        $scope.SES_ECPENSNUM_SA,
        $scope.SES_ECFOSTNUM_SA,
        $scope.SES_ECDISNUM_SA,
        $scope.SES_ECOTHNUM_SA,
        $scope.SES_ECOTHNUM_SA_Other,
        $scope.SES_ECCTFSWGNU_Z,
        $scope.SES_ECOTHNUM_Z,
        $scope.SES_ECOTHNUM_OTHER_Z,
        $scope.SES_ECFSMON,
        $scope.SES_ECRELIEF,
        $scope.SES_ECMEALS,
        $scope.SES_ECSHORT,
        $scope.SES_ECHHITEM,
        $scope.SES_ECBOR,
        $scope.SES_ECBELONG,
        $scope.SES_ECAWAY
      ]);
    } else {
      executeQuery += "PIN_Community_code_NO," +
      "Census_zone_number_NO," +
      "Census_block_number_NO," +
      "Census_plot_house_number_NO," +
      "Census_HHresults_NO," +
      "Census_HH_results_Other_NO";
      executeQuery += ") VALUES (?,?,?,?,?,?,?);";
      values = values.concat([
        $scope.PIN_Community_code_NO,
        $scope.Census_zone_number_NO,
        $scope.Census_block_number_NO,
        $scope.Census_plot_house_number_NO,
        $scope.Census_HH_results_NO,
        ($scope.Census_HH_results_NO == '8' ? $scope.Census_HH_results_NO_Other : "null")
      ]);
    }

    var db = openDatabase('treats', '1.0', 'TREATS DB', 5 * 1024 * 1024);

    db.transaction(function(transaction) {
      transaction.executeSql(executeQuery, values , function(tx, result) {
        var insertID =  result.insertId;

        if (len > 0) {
          for (i = 0; i < len; i++) {
            var member = hhmembers[i];
            memberQuery = "INSERT INTO participant_tbl (" +
            "pid," +
            "hhid," +
            "Census_Age," +
            "Census_Sex," +
            "Census_firstname," +
            "Census_surname," +
            "Census_HH," +
            "Census_Marital_status," +
            "Census_Occupation," +
            "Census_Occupation_other," +
            "Census_Education," +
            "Census_Education_higher_details," +
            "Census_HHresidence," +
            "Census_HH_residence_length," +
            "Census_HH_Present_visit_number," +
            "Census_Eligible," +
            "Census_Eligible_available," +
            "Census_Invited," +
            "PIN_Participant_number," +
            "Census_Barcode," +
            "Census_Consent," +
            "Census_Consent_reason_no_consent," +
            "Census_Assent," +
            "Census_Assent_reason_no_consent) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";

            values = [
              member.PIN,
              insertID,
              member.Census_Age,
              member.Census_Sex,
              member.Census_firstname,
              member.Census_surname,
              member.Census_HH,
              member.Census_Marital_status,
              member.Census_Occupation,
              member.Census_Occupation_other,
              member.Census_Education,
              member.Census_Education_higher_details,
              member.Census_HHresidence,
              member.Census_HH_residence_length,
              member.Census_HH_Present_visit_number,
              member.Census_Eligible,
              member.Census_Eligible_available,
              member.Census_Invited,
              member.PIN_Participant_number,
              member.PIN,
              member.Census_Consent,
              member.Census_Consent_reason_no_consent,
              member.Census_Assent,
              member.Census_Assent_reason_no_consent
            ];

            tx.executeSql(memberQuery, values , function(tx, result) {
                if (len == i) {
                  alert('Household data saved.');
                  setTimeout(function() {
                    window.location.reload();
                  }, 500);
                } else {
                  console.log("len: " + len + " | i: " + i);
                }
            }, function(tx, error) {
              alert('Error: ' + error.message);
            });
          }

        } else {
          alert('Household data saved.');
          setTimeout(function() {
            window.location.reload();
          }, 500);
        }
      }, function(tx, error) {
        alert('Error: ' + error.message);
      });
    });

  }

  $scope.getLocation = function() {
    navigator.geolocation.getCurrentPosition(function(position) {
      $scope.Census_GPS_Waypoint = position.coords.latitude.toString() + "," + position.coords.longitude.toString();
    }, function(error) {
        alert('code: '    + error.code    + '\n' +
        'message: ' + error.message + '\n');
    }, {enableHighAccuracy: true});
  }
});

app.controller('ListController', function($scope) {
    // myDB = window.sqlitePlugin.openDatabase({name: "mySQLite.treats", location: 'default'});
    var db = openDatabase('treats', '1.0', 'TREATS DB', 5 * 1024 * 1024);
    $scope.households = [];
    $scope.participants = [];

    db.transaction(function(transaction) {
      transaction.executeSql('SELECT * FROM household_tbl', [], function (tx, results) {
        var len = results.rows.length, i;

        for (i = 0; i < len; i++){
          $scope.households.push($scope.hhToDisplay(results.rows.item(i)));
        }

        $scope.$apply();
      }, function(tx, error) {
        alert('Error: ' + error.message);
      });
    });

    db.transaction(function(transaction) {
      transaction.executeSql('SELECT * FROM participant_tbl', [], function (tx, results) {
        var len = results.rows.length, i;
        console.log(results.rows.length);

        for (i = 0; i < len; i++) {
          $scope.participants.push($scope.memberToDisplay(results.rows.item(i)));
        }

        $scope.$apply();
      }, function(tx, error) {
        alert('Error: ' + error.message);
      });
    });

    $scope.hhToDisplay = function(item) {

      var d = {}, item = angular.extend({}, item);

      d['permission'] = (item.Census_permissionHHinterview == '1' ? 'Yes' : 'No');
      d['community_code'] = (item.Census_permissionHHinterview == '1' ? item.PIN_Community_code_YES : item.PIN_Community_code_NO);
      d['zone_number'] = (item.Census_permissionHHinterview == '1' ? item.Census_zone_number_YES : item.Census_zone_number_NO);
      d['block_number'] = (item.Census_permissionHHinterview == '1' ? item.Census_block_number_YES : item.Census_block_number_NO);
      d['plot_house_number'] = (item.Census_permissionHHinterview == '1' ? item.Census_plot_house_number_YES : item.Census_plot_house_number_NO);
      d['hh_number'] = (item.Census_permissionHHinterview == '1' ? item.PIN_Household_number : '');
      return d;
    }


    $scope.memberToDisplay = function(item) {
      var d = {}, item = angular.extend({}, item);

      d['age'] = item.Census_Age;
      d['eligible'] = (item.Census_Age >= '15' ? 'Yes' : 'No');
      d['name'] = item.Census_firstname;
      d['surname'] = item.Census_surname;
      d['pin'] = item.pid;
      return d;
    }
});

app.controller('ExportController', function($scope, $http) {
  // var myDB = window.sqlitePlugin.openDatabase({name: "mySQLite.treats", location: 'default'});
  var db = openDatabase('treats', '1.0', 'TREATS DB', 5 * 1024 * 1024);
  $scope.data = [];
  $scope.participants = [];

  db.transaction(function(transaction) {
    transaction.executeSql('SELECT * FROM household_tbl', [], function (tx, results) {
      var len = results.rows.length, i;

      for (i = 0; i < len; i++){
        $scope.data.push(angular.extend({}, results.rows.item(i)));
        // var hhp = [];
        // row = results.rows.item(i);

        // transaction.executeSql('SELECT * FROM participant_tbl where hhid = ? ', [row.id], function (itx, inner_results) {
        //   // $scope.data.push(angular.extend({}, row));

        //   for (x = 0; x < inner_results.rows.length; x++)
        //   {
        //     hhp.push(angular.extend({}, inner_results.rows.item(x)));
        //   }

        //   row.participants = hhp;
        //   $scope.data.push(row);
        // });
      }
    }, function(tx, error) {
      alert('Error: ' + error.message);
    });

    transaction.executeSql('SELECT * FROM participant_tbl', [], function (tx, results) {
      var len = results.rows.length, i;

      for (i = 0; i < len; i++) {
        $scope.participants.push(angular.extend({}, results.rows.item(i)));
      }
    }, function(tx, error) {
      alert('Error: ' + error.message);
    });

    $scope.$apply();
  });

  $scope.exportSubmit = function() {
    var db = openDatabase('treats', '1.0', 'TREATS DB', 5 * 1024 * 1024);

    var data = {'data': {'household': JSON.stringify($scope.data), 'participants': JSON.stringify($scope.participants)}};
      $.post(
        $scope.url + '/scripts/import_all.php',
        data,
        function(data) {
          data = JSON.parse(data);

          if (data.success) {
            db.transaction(function(transaction) {
              transaction.executeSql('DELETE FROM household_tbl', [], function (tx, results) {
                
              });

              transaction.executeSql('DELETE FROM participant_tbl', [], function (tx, results) {
                
              });

              alert("Data successfully exported.");
            });
          } else {
            alert("An error occured. " + data.message);
          }
        }
      );

      return false;

      //Send household data
      $.post(
        $scope.url + '/scripts/import_household.php',
        {'data': JSON.stringify($scope.data)},
        function(data) {
          data = JSON.parse(data);

          if (data.success) {
            db.transaction(function(transaction) {
              transaction.executeSql('DELETE FROM household_tbl', [], function (tx, results) {
                alert("Household data exported successfully.");
              });
            });
          } else {
            alert("An error occured. " + data.message);
          }
        }
      );

      //Send participant data
      $.post(
        $scope.url + '/scripts/import_participant.php',
        {'data': {'household': JSON.stringify($scope.data), 'participants': JSON.stringify($scope.participants)}},
        function(data) {
          data = JSON.parse(data);

          if (data.success) {
            db.transaction(function(transaction) {
              transaction.executeSql('DELETE FROM participant_tbl', [], function (tx, results) {
                alert("Participant data exported successfully.");
              });
            });
          } else {
            alert("An error occured. " + data.message);
          }
        }
      );

    return false;
  }
});


$(function() {
  $('#reset-database-old').click(function() {
    // var myDB = window.sqlitePlugin.openDatabase({name: "mySQLite.treats", location: 'default'});
    var db = openDatabase('treats', '1.0', 'TREATS DB', 5 * 1024 * 1024);
    db.transaction(function(transaction) {
      transaction.executeSql("DROP TABLE IF EXISTS household_tbl", [],
          function(tx, result) {
              alert("Household table dropped.");
          },
          function(tx, error) {
          alert("SQL Error: " + error.message);
      });

      transaction.executeSql("DROP TABLE IF EXISTS participant_tbl", [],
          function(tx, result) {
              alert("Participant table dropped.");
          },
          function(tx, error) {
          alert("SQL Error: " + error.message);
      });
    });

    window.localStorage.removeItem("dbStructureDone");
    setTimeout(function() {
      window.location.reload();
    }, 3500);
  });
});

function resetDatabase() {
  console.log("Resetting database!!");

  var db = openDatabase('treats', '1.0', 'TREATS DB', 5 * 1024 * 1024);
    db.transaction(function(transaction) {
      transaction.executeSql("DROP TABLE IF EXISTS household_tbl", [],
          function(tx, result) {
              alert("Household table dropped.");
          },
          function(tx, error) {
          alert("SQL Error: " + error.message);
      });

      transaction.executeSql("DROP TABLE IF EXISTS participant_tbl", [],
          function(tx, result) {
              alert("Participant table dropped.");
          },
          function(tx, error) {
          alert("SQL Error: " + error.message);
      });
    });

    window.localStorage.removeItem("dbStructureDone");
    setTimeout(function() {
      window.location.reload();
    }, 3500);

  return false;
}

(function($) {

  $.fn.menumaker = function(options) {

      var cssmenu = $(this), settings = $.extend({
        title: "Menu",
        format: "dropdown",
        sticky: false
      }, options);

      return this.each(function() {
        cssmenu.prepend('<div id="menu-button">' + settings.title + '</div>');
        $(this).find("#menu-button").on('click', function(){
          $(this).toggleClass('menu-opened');
          var mainmenu = $(this).next('ul');
          if (mainmenu.hasClass('open')) {
            mainmenu.hide().removeClass('open');
          }
          else {
            mainmenu.show().addClass('open');
            if (settings.format === "dropdown") {
              mainmenu.find('ul').show();
            }
          }
        });

        cssmenu.find('li ul').parent().addClass('has-sub');

        cssmenu.find('a').on('click', function() {
          $('#menu-button').trigger('click');
        });

        multiTg = function() {
          cssmenu.find(".has-sub").prepend('<span class="submenu-button"></span>');
          cssmenu.find('.submenu-button').on('click', function() {
            $(this).toggleClass('submenu-opened');
            if ($(this).siblings('ul').hasClass('open')) {
              $(this).siblings('ul').removeClass('open').hide();
            }
            else {
              $(this).siblings('ul').addClass('open').show();
            }
          });
        };

        if (settings.format === 'multitoggle') multiTg();
        else cssmenu.addClass('dropdown');

        if (settings.sticky === true) cssmenu.css('position', 'fixed');

        resizeFix = function() {
          if ($( window ).width() > 768) {
            cssmenu.find('ul').show();
          }

          if ($(window).width() <= 768) {
            cssmenu.find('ul').hide().removeClass('open');
          }
        };
        resizeFix();
        return $(window).on('resize', resizeFix);

      });
  };
})(jQuery);

(function($){
  $(document).ready(function() {

    $("#cssmenu").menumaker({
      title: "Menu",
      format: "multitoggle"
    });

  });

  $('input[type="number"]').on('keypress', function (event) {
      var charCode = (event.which) ? event.which : event.keyCode
      if (charCode > 31 && (charCode < 48 || charCode > 57))
          return false;

      return true;
  });

  $('input[type="number"]').on('change', function () {
      console.log("Changed!!");

      if ($(this).has('min') && (parseInt($(this).val()) < parseInt($(this).attr('min')))) {
          alert('Minimum value is ' + $(this).attr('min') + '. Value will be cleared. Please enter a new one within range');
          $(this).val('');
      }

      if ($(this).attr('max') && (parseInt($(this).val()) > parseInt($(this).attr('max')))) {
          alert('Maximum value is ' + $(this).attr('max') + '. Value will be cleared. Please enter a new one within range');
          $(this).val('');
      }
  });
})(jQuery);
