/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var app = {
    // Application Constructor
    initialize: function() {
        document.addEventListener('deviceready', this.onDeviceReady.bind(this), false);
    },

    // deviceready Event Handler
    //
    // Bind any cordova events here. Common events are:
    // 'pause', 'resume', etc.
    onDeviceReady: function() {
        // document.getElementById("new_activity").addEventListener("click", new_activity);

        if(window.localStorage.getItem("dbStructureDone") === null) {
            // Running for the first time. Create tables
            var household_tbl = "CREATE TABLE IF NOT EXISTS `household_tbl` (id integer primary key," +
                "`Census_permissionHHinterview` integer DEFAULT NULL," +
                "`Census_date` date DEFAULT NULL," +
                "`PIN_Community_code_YES` integer DEFAULT NULL," +
                "`Census_zone_number_YES` integer DEFAULT NULL," +
                "`Census_block_number_YES` integer DEFAULT NULL," +
                "`Census_plot_house_number_YES` integer DEFAULT NULL," +
                "`PIN_Household_number` integer DEFAULT NULL," +
                "`Census_GPS_Waypoint` text DEFAULT NULL," +
                "`Census_interviewer_name` text DEFAULT NULL," +
                "`Census_interviewer_code` integer DEFAULT NULL," +
                "`Census_HHresults` integer DEFAULT NULL," +
                "`Census_HH_results_Other` text," +
                "`SES_ECBUILD` integer DEFAULT NULL," +
                "`SES_ECBUILD_Other` text DEFAULT NULL," +
                "`SES_ECFLOOR` integer DEFAULT NULL," +
                "`SES_ECFLOOR_Other` text DEFAULT NULL," +
                "`SES_ECROOM` integer DEFAULT NULL," +
                "`SES_ECROOMSLEEP` integer DEFAULT NULL," +
                "`SES_ECWATER` integer DEFAULT NULL," +
                "`SES_ECWATER_Other` text DEFAULT NULL," +
                "`SES_ECENERGY` integer DEFAULT NULL," +
                "`SES_ECENERGY_Other` text DEFAULT NULL," +
                "`SES_ECTOILET` integer DEFAULT NULL," +
                "`SES_ECTOILET_Other` text DEFAULT NULL," +
                "`SES_ECITEM1` tinyint(4) DEFAULT NULL," +
                "`SES_ECITEM2` tinyint(4) DEFAULT NULL," +
                "`SES_ECITEM3` tinyint(4) DEFAULT NULL," +
                "`SES_ECITEM4` tinyint(4) DEFAULT NULL," +
                "`SES_ECITEM5` tinyint(4) DEFAULT NULL," +
                "`SES_ECITEM6` tinyint(4) DEFAULT NULL," +
                "`SES_ECITEM7` tinyint(4) DEFAULT NULL," +
                "`SES_ECITEM8` tinyint(4) DEFAULT NULL," +
                "`SES_ECITEM9` tinyint(4) DEFAULT NULL," +
                "`SES_ECITEM10` tinyint(4) DEFAULT NULL," +
                "`SES_ECITEM11` tinyint(4) DEFAULT NULL," +
                "`SES_ECITEM12` tinyint(4) DEFAULT NULL," +
                "`SES_ECITEMNR` integer DEFAULT NULL," +
                "`SES_ECITEM0` tinyint(4) DEFAULT NULL," +
                "`SES_ECINCOME` integer DEFAULT NULL," +
                "`SES_ECINCOME_Other` text DEFAULT NULL," +
                "`SES_ECGRANT` tinyint(4) DEFAULT NULL," +
                "`SES_ECCHILDNUM_SA` tinyint(4) DEFAULT NULL," +
                "`SES_ECPENSNUM_SA` tinyint(4) DEFAULT NULL," +
                "`SES_ECFOSTNUM_SA` tinyint(4) DEFAULT NULL," +
                "`SES_ECDISNUM_SA` tinyint(4) DEFAULT NULL," +
                "`SES_ECOTHNUM_SA` tinyint(4) DEFAULT NULL," +
                "`SES_ECOTHNUM_SA_Other` text DEFAULT NULL," +
                "`SES_ECCTFSWGNU_Z` tinyint(4) DEFAULT NULL," +
                "`SES_ECOTHNUM_Z` tinyint(4) DEFAULT NULL," +
                "`SES_ECOTHNUM_OTHER_Z` text DEFAULT NULL," +
                "`SES_ECFSMON` integer DEFAULT NULL," +
                "`SES_ECRELIEF` tinyint(4) DEFAULT NULL," +
                "`SES_ECMEALS` tinyint(4) DEFAULT NULL," +
                "`SES_ECSHORT` tinyint(4) DEFAULT NULL," +
                "`SES_ECHHITEM` tinyint(4) DEFAULT NULL," +
                "`SES_ECBOR` tinyint(4) DEFAULT NULL," +
                "`SES_ECBELONG` tinyint(4) DEFAULT NULL," +
                "`SES_ECAWAY` tinyint(4) DEFAULT NULL," +
                "`PIN_Community_code_NO` integer DEFAULT NULL," +
                "`Census_zone_number_NO` integer DEFAULT NULL," +
                "`Census_block_number_NO` integer DEFAULT NULL," +
                "`Census_plot_house_number_NO` integer DEFAULT NULL," +
                "`Census_HHresults_NO` integer DEFAULT NULL," +
                "`Census_HH_results_Other_NO` text," +
                "`created` TIMESTAMP DEFAULT CURRENT_TIMESTAMP," +
                "`modified` TIMESTAMP DEFAULT CURRENT_TIMESTAMP" +
            ")";

            var participant_tbl = "CREATE TABLE IF NOT EXISTS `participant_tbl` (id integer primary key," +
                "`pid` char(8) DEFAULT NULL," +
                "`hhid` integer DEFAULT NULL," +
                "`Census_Age` integer DEFAULT NULL," +
                "`Census_Sex` integer DEFAULT NULL," +
                "`Census_firstname` text DEFAULT NULL," +
                "`Census_surname` text DEFAULT NULL," +
                "`Census_HH` integer DEFAULT NULL," +
                "`Census_Marital_status` integer DEFAULT NULL," +
                "`Census_Occupation` integer DEFAULT NULL," +
                "`Census_Occupation_other` text DEFAULT NULL," +
                "`Census_Education` integer DEFAULT NULL," +
                "`Census_Education_higher_details` text DEFAULT NULL," +
                "`Census_HHresidence` integer DEFAULT NULL," +
                "`Census_HH_residence_length` integer DEFAULT NULL," +
                "`Census_HH_Present_visit_number` integer DEFAULT NULL," +
                "`Census_Eligible` integer DEFAULT NULL," +
                "`Census_Eligible_available` integer DEFAULT NULL," +
                "`Census_Invited` integer DEFAULT NULL," +
                "`PIN_Participant_number` integer DEFAULT NULL," +
                "`Census_Barcode` integer DEFAULT NULL," +
                "`Census_Consent` integer DEFAULT NULL," +
                "`Census_Consent_reason_no_consent` text DEFAULT NULL," +
                "`Census_Assent` integer DEFAULT NULL," +
                "`Census_Assent_reason_no_consent` text DEFAULT NULL," +
                "`created` TIMESTAMP DEFAULT CURRENT_TIMESTAMP," +
                "`modified` TIMESTAMP DEFAULT CURRENT_TIMESTAMP)";
        //     myDB = window.sqlitePlugin.openDatabase({name: "mySQLite.treats", location: 'default'});

        //     myDB.transaction(function(transaction) {
        //         transaction.executeSql(household_tbl, [],
        //             function(tx, result) {
        //                 alert("Household table created successfully");
        //             },
        //             function(error) {
        //             alert("Error occurred while creating the household table.");
        //         });
        //     });

        //     myDB.transaction(function(transaction) {
        //         transaction.executeSql(participant_tbl, [],
        //             function(tx, result) {
        //                 alert("Household table created successfully");
        //             },
        //             function(error) {
        //             alert("Error occurred while creating the participant table.");
        //         });
        //     });

            //Use WebSQL
            var db = openDatabase('treats', '1.0', 'TREATS DB', 5 * 1024 * 1024);
            db.transaction(function (tx) {
                tx.executeSql(household_tbl, [],
                    function(tx, result) {
                        alert("Household table created successfully");
                    },
                    function(error) {
                    alert("Error occurred while creating the participant table.");
                });

                tx.executeSql(participant_tbl, [],
                    function(tx, result) {
                        alert("Participant table created successfully");
                    },
                    function(error) {
                    alert("Error occurred while creating the participant table.");
                });
             });

            window.localStorage.setItem("dbStructureDone", 1);
        } else {
            // alert(window.localStorage.getItem("dbStructureDone"));
        }

        //set zoom
        if(window.MobileAccessibility) {
            window.MobileAccessibility.getTextZoom(getTextZoomCallback);
            window.MobileAccessibility.usePreferredTextZoom(false);
        }
    },

    // Update DOM on a Received Event
    receivedEvent: function(id) {
        // var parentElement = document.getElementById(id);
        // var listeningElement = parentElement.querySelector('.listening');
        // var receivedElement = parentElement.querySelector('.received');
        //
        // listeningElement.setAttribute('style', 'display:none;');
        // receivedElement.setAttribute('style', 'display:block;');
        //
        // console.log('Received Event: ' + id);
    }
};



app.initialize();

function getTextZoomCallback(textZoom) {
    if (textZoom == 100) {
        window.MobileAccessibility.setTextZoom(125, setTextZoomCallback);
    }
}

function setTextZoomCallback(new_zoom) {
    console.log(new_zoom);
}

function new_activity() {
    EpsonPrint.coolMethod("JB007", function(data) {
        alert("Returned data: " + data);
    }, function(error) {
        alert("Error: " + error);
    });
}

function sendToPrinter(pin) {
    EpsonPrint.coolMethod(pin, function(data) {
        // alert("" + data);
    }, function(error) {
        alert("Error: " + error);
    });
}
